Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -998,45 +1868,32 @@
                 {
                     m_cost_ins_miss_frz++;
-                    if ( r_tgt_icache_req ) {   // external request
-                        r_icache_fsm = ICACHE_CC_CHECK;
-                        r_icache_fsm_save = r_icache_fsm.read();
+                    if ( r_tgt_icache_req[num_cache] ) {   // external request
+                        r_icache_fsm      [num_cache] = ICACHE_CC_CHECK;
+                        r_icache_fsm_save [num_cache] = r_icache_fsm[num_cache].read();
                         break;
                     }
 
-                    bool val = CACHE_MISS_BUF_RSP_VAL(i,0);
-
-                    PRINTF("    * <ICACHE> val                  : %d\n",val);
+                    bool val = CACHE_MISS_BUF_RSP_VAL(i,num_cache,0);
+
+                    PRINTF("    * <ICACHE [%d]> val                  : %d\n",num_cache,val);
 
                     if (val)
                     {
-                        PRINTF("    * <ICACHE> r_icache_inval_rsp   : %d\n",(int) r_icache_inval_rsp  );
-                        PRINTF("    * <ICACHE> r_vci_rsp_ins_error  : %d\n",(int) r_vci_rsp_ins_error );
-                        PRINTF("    * <ICACHE> r_icache_cleanup_req : %d\n",(int) r_icache_cleanup_req);
-
-                        // if (not r_icache_inval_rsp )
-                        // {
-                            // Miss read response and no invalidation
-                            if ( r_vci_rsp_ins_error ) {
-                                r_icache_fsm = ICACHE_ERROR;
-                            } else {
+                        PRINTF("    * <ICACHE [%d]> r_icache_inval_rsp   : %d\n",num_cache,(int) r_icache_inval_rsp  [num_cache]);
+                        PRINTF("    * <ICACHE [%d]> r_vci_rsp_ins_error  : %d\n",num_cache,(int) r_vci_rsp_ins_error [num_cache]);
+                        PRINTF("    * <ICACHE [%d]> r_icache_cleanup_req : %d\n",num_cache,(int) r_icache_cleanup_req[num_cache]);
+
+                        // Miss read response and no invalidation
+                        if ( r_vci_rsp_ins_error [num_cache]) {
+                            r_icache_fsm[num_cache] = ICACHE_ERROR;
+                        } else {
 #if not CC_XCACHE_WRAPPER_SELECT_VICTIM
-                                if (not r_icache_cleanup_req.read())
-#endif
-                                {
-                                    r_icache_update_addr = 0;
-                                    r_icache_fsm         = ICACHE_MISS_UPDT;
-                                }
+                            if (not r_icache_cleanup_req[num_cache].read())
+#endif
+                            {
+                                r_icache_update_addr[num_cache] = 0;
+                                r_icache_fsm        [num_cache] = ICACHE_MISS_UPDT;
                             }
-                        // }
-                        // else
-                        // {
-                        //     r_icache_inval_rsp = false;
-                            
-                        //     // Miss read response and invalidation
-                        //     if ( r_vci_rsp_ins_error )
-                        //         r_icache_fsm = ICACHE_ERROR;
-                        //     else
-                        //         r_icache_fsm = ICACHE_CC_CLEANUP;
-                        // }
+                        }
                     }
                     break;
@@ -1046,19 +1903,22 @@
                 {
                     m_cost_ins_miss_frz++;
-                    if ( r_tgt_icache_req ) {   // external request
-                        r_icache_fsm = ICACHE_CC_CHECK;
-                        r_icache_fsm_save = r_icache_fsm.read();
+                    if ( r_tgt_icache_req[num_cache] ) {   // external request
+                        r_icache_fsm     [num_cache] = ICACHE_CC_CHECK;
+                        r_icache_fsm_save[num_cache] = r_icache_fsm[num_cache].read();
                         break;
                     }
 
-                    bool ok = CACHE_MISS_BUF_RSP_VAL(i,0);
+                    bool ok = CACHE_MISS_BUF_RSP_VAL(i,num_cache,0);
+
+                    PRINTF("    * <ICACHE [%d]> ok                   : %d\n",num_cache,ok);
+                    PRINTF("    * <ICACHE [%d]> error                : %d\n",num_cache,(uint32_t)r_vci_rsp_ins_error [num_cache]);
 
                     if (ok)
                     {
-                        if ( r_vci_rsp_ins_error ) {
-                            r_icache_fsm = ICACHE_ERROR;
+                        if ( r_vci_rsp_ins_error [num_cache]) {
+                            r_icache_fsm[num_cache] = ICACHE_ERROR;
                         } else {
-                            r_icache_fsm = ICACHE_IDLE;
-                            r_icache_buf_unc_valid = true;
+                            r_icache_fsm [num_cache] = ICACHE_IDLE;
+                            r_icache_buf_unc_valid[num_cache] = true;
                         }
                     }
@@ -1068,10 +1928,10 @@
             case ICACHE_ERROR:
                 {
-                    if ( (addr_40)ireq.addr == (addr_40)r_icache_addr_save ) {
-                        irsp.error          = true;
-                        irsp.valid          = true;
-                    }
-                    r_icache_fsm = ICACHE_IDLE;
-                    r_vci_rsp_ins_error = false;
+                    if ( (addr_40)_ireq.addr == (addr_40)r_icache_addr_save[num_cache] ) {
+                        _irsp.error          = true;
+                        _irsp.valid          = true;
+                    }
+                    r_icache_fsm        [num_cache] = ICACHE_IDLE;
+                    r_vci_rsp_ins_error [num_cache] = false;
                     break;
                 }
@@ -1079,17 +1939,16 @@
             case ICACHE_MISS_UPDT: 
                 {
-                    size_t     word = r_icache_update_addr.read();
-                    vci_addr_t addr = (vci_addr_t) r_icache_addr_save.read();
+                    size_t     word =              r_icache_update_addr[num_cache].read();
+                    vci_addr_t addr = (vci_addr_t) r_icache_addr_save  [num_cache].read();
                     size_t     way  = 0;
                     size_t     set  = 0;
 
+#if CC_XCACHE_WRAPPER_SELECT_VICTIM
+                    way = r_icache_miss_way[num_cache].read();
+                    set = r_icache_miss_set[num_cache].read();
+#else
                     // need invalid rsp, don't select a victim
-                    if (not r_icache_inval_rsp )
+                    if (not r_icache_inval_rsp[num_cache])
                     {
-#if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                        way = r_icache_miss_way.read();
-                        set = r_icache_miss_set.read();
-#else
-
                         // First word : select an victim !
                         if (word == 0)
@@ -1098,52 +1957,55 @@
                         
                             // r_icache_cleanup_req is false because is the transition condition to go in ICACHE_MISS_UPDT state
-                            r_icache_cleanup_req  = r_icache.victim_select(addr, &victim, &way, &set );
-                            r_icache.victim_update_tag(addr, way, set);
+                            r_icache_cleanup_req[num_cache]  = r_icache[num_cache]->victim_select(addr, &victim, &way, &set );
+                            r_icache[num_cache]->victim_update_tag(addr, way, set);
                         
-                            r_icache_cleanup_line = (addr_40) victim;
-                            r_icache_miss_way     = way;
-                            r_icache_miss_set     = set;
+                            r_icache_cleanup_line[num_cache] = (addr_40) victim;
+                            r_icache_miss_way    [num_cache] = way;
+                            r_icache_miss_set    [num_cache] = set;
                         }
                         else
                         {
-                            way = r_icache_miss_way.read();
-                            set = r_icache_miss_set.read();
+                            way = r_icache_miss_way[num_cache].read();
+                            set = r_icache_miss_set[num_cache].read();
                         }
-#endif
-                    }
-                    bool val = CACHE_MISS_BUF_RSP_VAL(i,word);
+                    }
+#endif
+                    bool val = CACHE_MISS_BUF_RSP_VAL(i,num_cache,word);
 
                     if (val)
                     {
-                        PRINTF("    * <ICACHE> rsp_val            : %d/%d\n",(int)r_icache_update_addr,m_icache_words);
-                        PRINTF("    * <ICACHE> r_icache_inval_rsp : %d\n",(int)r_icache_inval_rsp);
-                        PRINTF("    * <ICACHE> ins : %x\n",(int)CACHE_MISS_BUF_RSP_DATA(i,word));
+                        PRINTF("    * <ICACHE [%d]> rsp_val            : %d/%d\n",num_cache,(int)r_icache_update_addr[num_cache],m_icache_words);
+                        PRINTF("    * <ICACHE [%d]> r_icache_inval_rsp : %d\n"   ,num_cache,(int)r_icache_inval_rsp[num_cache]);
+                        PRINTF("    * <ICACHE [%d]> ins                : %x\n"   ,num_cache,(int)CACHE_MISS_BUF_RSP_DATA(i,num_cache,word));
 
                         // m_cpt_icache_dir_write++;
                         // m_cpt_icache_data_write++;
-                        // if ( ireq.valid ) m_cost_ins_miss_frz++;
+                        // if ( _ireq.valid ) m_cost_ins_miss_frz++;
 
                         // if need invalid rsp, don't modify the cache, but pop the buf_rsp
-                        if (not r_icache_inval_rsp )
-                            r_icache.write(way, set, word, CACHE_MISS_BUF_RSP_DATA(i,word));
-                        CACHE_MISS_BUF_RSP_POP(i);
-
-                        r_icache_update_addr = ++word;
+                        if (not r_icache_inval_rsp[num_cache])
+                            r_icache[num_cache]->write(way, set, word, CACHE_MISS_BUF_RSP_DATA(i,num_cache,word));
+
+                        CACHE_MISS_BUF_RSP_POP(i,num_cache);
+
+                        r_icache_update_addr[num_cache] = ++word;
                             
                         // if last word, finish the update
                         if (word >= m_icache_words)
                         {
+#if CC_XCACHE_WRAPPER_SELECT_VICTIM
+                            // in all case (inval_rsp or not), update the victim tag
+                            r_icache[num_cache]->victim_update_tag(addr, way, set);
+#endif
+
                             // Last word : if previous invalid_rsp, can cleanup, else update the TAG
-                            if (r_icache_inval_rsp)
+                            if (r_icache_inval_rsp[num_cache])
                             {
-                                r_icache_inval_rsp  = false;
-                                r_icache_fsm = ICACHE_CC_CLEANUP;
+                                r_icache_inval_rsp[num_cache] = false;
+                                r_icache_fsm      [num_cache] = ICACHE_CC_CLEANUP;
                             }
                             else
                             {
-#if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                                r_icache.victim_update_tag(addr, way, set);
-#endif
-                                r_icache_fsm = ICACHE_IDLE;
+                                r_icache_fsm [num_cache] = ICACHE_IDLE;
                             }
                         }
@@ -1156,15 +2018,19 @@
                 {
                     // external cache invalidate request
-                    if ( r_tgt_icache_req )     
+                    if ( r_tgt_icache_req[num_cache])     
                     {
-                        r_icache_fsm = ICACHE_CC_CHECK;
-                        r_icache_fsm_save = r_icache_fsm.read();
+                        r_icache_fsm     [num_cache] = ICACHE_CC_CHECK;
+                        r_icache_fsm_save[num_cache] = r_icache_fsm[num_cache].read();
                         break;
                     }
                     // cleanup
-                    if(not r_icache_cleanup_req){
-                        r_icache_cleanup_req = true;
-                        r_icache_cleanup_line = r_icache_addr_save.read() >> m_icache_words_shift;
-                        r_icache_fsm = ICACHE_IDLE;
+                    if(not r_icache_cleanup_req[num_cache]){
+                        r_icache_cleanup_req [num_cache] = true;
+                        r_icache_cleanup_line[num_cache] = r_icache_addr_save[num_cache].read() >> m_icache_words_shift;
+                        r_icache_fsm         [num_cache] = ICACHE_IDLE;
+
+                        // FIXME : too many access at the cache in this cycle
+                        m_cpt_icache_dir_read += m_icache_ways;
+                        r_icache[num_cache]->inval((addr_40)r_icache_addr_save[num_cache]);
                     }
                     break;
@@ -1176,20 +2042,29 @@
                     m_cpt_icache_dir_read  += m_icache_ways;
                     m_cpt_icache_data_read += m_icache_ways;
-                    addr_40 ad = r_tgt_addr;
+                    addr_40 ad = r_tgt_iaddr;
                     data_t  icache_rdata = 0;
 
-                    if((r_icache_fsm_save == ICACHE_MISS_WAIT) and 
-                            ( (r_icache_addr_save.read() & ~((m_icache_words<<2)-1)) == (ad & ~((m_icache_words<<2)-1)))) {
-                        r_icache_inval_rsp = true;
-                        r_tgt_icache_req = false;
+                    PRINTF("    * <ICACHE [%d]> CC_CHECK\n",num_cache);
+
+                    if((r_icache_fsm_save[num_cache] == ICACHE_MISS_WAIT) and 
+                       ((r_icache_addr_save[num_cache].read() & ~((m_icache_words<<2)-1)) == (ad & ~((m_icache_words<<2)-1)))) {
+                        PRINTF("    * <ICACHE [%d]> have request, need inval rsp\n",num_cache);
+
+                        r_icache_inval_rsp[num_cache] = true;
+                        r_tgt_icache_req  [num_cache] = false;
                         if(r_tgt_update){    // Also send a cleanup and answer
-                            r_tgt_icache_rsp     = true;
+                            PRINTF("    * <ICACHE [%d]> send a cleanup and answer\n",num_cache);
+                            r_tgt_icache_rsp[num_cache] = true;
                         } else {            // Also send a cleanup but don't answer
-                            r_tgt_icache_rsp     = false;
+                            PRINTF("    * <ICACHE [%d]> send a cleanup and but don't answer\n",num_cache);
+                            r_tgt_icache_rsp[num_cache] = false;
                         }
-                        r_icache_fsm = r_icache_fsm_save;
+                        r_icache_fsm[num_cache] = r_icache_fsm_save[num_cache];
                     } else {
-                        bool    icache_hit   = r_icache.read(ad, &icache_rdata);
-                        if ( icache_hit and r_tgt_update ) 
+                        bool    icache_hit   = r_icache[num_cache]->read(ad, &icache_rdata);
+
+                        PRINTF("    * <ICACHE [%d]> have no request, hit cache : %d\n",num_cache,icache_hit);
+
+                        if ( icache_hit and r_tgt_update) 
                         {
 #if CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
@@ -1198,5 +2073,5 @@
                             data_t   rdata = 0;
 
-                            r_icache.read(ad+word*4,&rdata);
+                            r_icache[num_cache]->read(ad+word*4,&rdata);
                             r_tgt_buf[word] = (mask & r_tgt_buf[word]) | (~mask & rdata);
                             
@@ -1210,5 +2085,5 @@
                             if (word==m_icache_words)
                             {
-                                r_icache_fsm = ICACHE_CC_UPDT;
+                                r_icache_fsm[num_cache] = ICACHE_CC_UPDT;
 
 #if CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE_OPT
@@ -1222,23 +2097,23 @@
                             r_cache_word = word;
 #else //CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
-                            r_icache_fsm = ICACHE_CC_UPDT;
+                            r_icache_fsm[num_cache] = ICACHE_CC_UPDT;
                             // complete the line buffer in case of update
                             for(size_t i=0; i<m_icache_words; i++){
                                 data_t rdata = 0;
-                                r_icache.read(ad + i*4,&rdata);
+                                r_icache[num_cache]->read(ad + i*4,&rdata);
                                 data_t mask = vci_param::be2mask(r_tgt_be[i]);
                                 r_tgt_buf[i] = (mask & r_tgt_buf[i]) | (~mask & rdata);
                             }
 #endif //CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
-                        } else if ( icache_hit and not r_tgt_update ) {
-                            r_icache_fsm = ICACHE_CC_INVAL;
+                        } else if ( icache_hit and not r_tgt_update) {
+                            r_icache_fsm[num_cache] = ICACHE_CC_INVAL;
                         } else { // instruction not found (can happen)
-                            r_tgt_icache_req = false;
+                            r_tgt_icache_req[num_cache] = false;
                             if(r_tgt_update){
-                                r_tgt_icache_rsp = true;
+                                r_tgt_icache_rsp[num_cache] = true;
                             } else {
-                                r_tgt_icache_rsp = false;
+                                r_tgt_icache_rsp[num_cache] = false;
                             }
-                            r_icache_fsm = r_icache_fsm_save;
+                            r_icache_fsm[num_cache] = r_icache_fsm_save[num_cache];
                         }
                     }
@@ -1248,11 +2123,11 @@
             case ICACHE_CC_INVAL:  
                 {                       
-                    addr_40    ad  = r_tgt_addr;
-                    if ( ireq.valid ) m_cost_ins_miss_frz++;
+                    addr_40 ad  = r_tgt_iaddr;
+                    // if ( _ireq.valid ) m_cost_ins_miss_frz++;
                     m_cpt_icache_dir_read += m_icache_ways;
-                    r_tgt_icache_rsp = true;
-                    r_icache.inval(ad);
-                    r_tgt_icache_req = false;
-                    r_icache_fsm = r_icache_fsm_save;
+                    r_tgt_icache_rsp[num_cache] = true;
+                    r_icache[num_cache]->inval(ad);
+                    r_tgt_icache_req[num_cache] = false;
+                    r_icache_fsm    [num_cache] = r_icache_fsm_save[num_cache];
                     break;
                 }    
@@ -1260,5 +2135,5 @@
             case ICACHE_CC_UPDT:
                 {                       
-                    addr_40 ad = r_tgt_addr.read();
+                    addr_40 ad = r_tgt_iaddr.read();
                     m_cpt_icache_dir_write++;
                     m_cpt_icache_data_write++;
@@ -1268,5 +2143,5 @@
 
                     if(r_tgt_be[word])
-                        r_icache.write(ad+word*4, r_tgt_buf[word]);
+                        r_icache[num_cache]->write(ad+word*4, r_tgt_buf[word]);
 
                     word ++;
@@ -1279,7 +2154,7 @@
                     if (word==m_icache_words)
                     {
-                        r_tgt_icache_req = false;
-                        r_tgt_icache_rsp = true;
-                        r_icache_fsm     = r_icache_fsm_save.read();
+                        r_tgt_icache_req[num_cache] = false;
+                        r_tgt_icache_rsp[num_cache] = true;
+                        r_icache_fsm    [num_cache] = r_icache_fsm_save[num_cache].read();
                         word = 0;
                     }
@@ -1288,9 +2163,9 @@
                     data_t* buf    = r_tgt_buf;
                     for(size_t i=0; i<m_icache_words;i++){
-                        if(r_tgt_be[i]) r_icache.write( ad + i*4, buf[i]);
-                    }
-                    r_tgt_icache_req = false;
-                    r_tgt_icache_rsp = true;
-                    r_icache_fsm     = r_icache_fsm_save.read();
+                        if(r_tgt_be[i]) r_icache[num_cache]->write( ad + i*4, buf[i]);
+                    }
+                    r_tgt_icache_req [num_cache] = false;
+                    r_tgt_icache_rsp [num_cache] = true;
+                    r_icache_fsm     [num_cache] = r_icache_fsm_save[num_cache].read();
 #endif //CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
 
@@ -1298,10 +2173,16 @@
                 }    
 
-        } // end switch r_icache_fsm
-
-#if CC_XCACHE_WRAPPER_DEBUG
-        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
-            std::cout << "    * Instruction Response : " << irsp << std::endl;
-#endif
+        }// end switch r_icache_fsm
+
+        irsp [num_cache] = _irsp;
+        if (_ireq.valid and _irsp.valid)
+        {
+            PRINTF("    * <CPU2CACHE> Transaction between cpu %d and Icache %d (unlock)\n",r_icache_lock [num_cache].read(),num_cache);
+
+            r_icache_lock       [num_cache] = m_nb_cpu;
+            m_cpt_icache_access [num_cache] ++;
+        }
+
+        }// end for num_cache
 
         //////////////////////////////////////////////////////////////////////://///////////
@@ -1361,35 +2242,36 @@
         ///////////////////////////////////////////////////////////////////////////////////
 
-#if CC_XCACHE_WRAPPER_DEBUG
-        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
-            std::cout << "    * Data        Request  : " << dreq << std::endl;
-#endif
-
-        switch ( r_dcache_fsm ) {
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        {
+            typename iss_t::DataRequest  _dreq = dreq [num_cache];
+            typename iss_t::DataResponse _drsp = ISS_DRSP_INITIALIZER;
+
+        switch ( r_dcache_fsm[num_cache]) {
 
                 /////////////////
             case DCACHE_IDLE:
                 {
-                    if ( r_tgt_dcache_req ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    if ( r_tgt_dcache_req[num_cache]) {   // external request
+                        r_dcache_fsm     [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save[num_cache] = r_dcache_fsm[num_cache];
                         break;
                     } 
 
-                    if ( dreq.valid ) {
-                        PRINTF("    * <DCACHE> Have dreq\n");
+                    if ( _dreq.valid ) {
+                        PRINTF("    * <DCACHE [%d]> Have dreq\n",num_cache);
 
                         data_t      dcache_rdata       = 0;
-                        // dcache_cached and dcache_hit don't used with dreq.type == {DATA_SC, XTN_READ, XTN_WRITE}
-                        bool        dcache_cached      = m_cacheability_table[(vci_addr_t)dreq.addr];
-                        bool        dcache_hit         = r_dcache.read((vci_addr_t) dreq.addr, &dcache_rdata);
-                        bool        dcache_cleanup_hit = r_dcache_cleanup_req and (((addr_40)dreq.addr >> (addr_40)m_dcache_words_shift) == r_dcache_cleanup_line.read());
-
-                        PRINTF("    * <DCACHE> hit %d - cached %d - cleanup_hit %d\n",dcache_hit, dcache_cached, dcache_cleanup_hit);
+                        // dcache_cached and dcache_hit don't used with _dreq.type == {DATA_SC, XTN_READ, XTN_WRITE}
+                        bool        dcache_cached      = dreq_cached  [num_cache];
+                        uint32_t    dcache_num_cpu     = dreq_num_cpu [num_cache];
+                        bool        dcache_hit         = r_dcache[num_cache]->read((vci_addr_t) _dreq.addr, &dcache_rdata);
+                        bool        dcache_cleanup_hit = r_dcache_cleanup_req[num_cache] and (((addr_40)_dreq.addr >> (addr_40)m_dcache_words_shift) == r_dcache_cleanup_line[num_cache].read());
+
+                        PRINTF("    * <DCACHE [%d]> hit %d - cached %d - cleanup_hit %d\n",num_cache,dcache_hit, dcache_cached, dcache_cleanup_hit);
                         
                         m_cpt_dcache_data_read += m_dcache_ways;
                         m_cpt_dcache_dir_read  += m_dcache_ways;
 
-                        switch( dreq.type ) {
+                        switch( _dreq.type ) {
                             case iss_t::DATA_READ:
                             case iss_t::DATA_LL:
@@ -1400,20 +2282,21 @@
                                         {
                                             // address is in the cache : return the word
-                                            r_dcache_fsm = DCACHE_IDLE;
-                                            drsp.valid   = true;
-                                            drsp.rdata   = dcache_rdata; // return read data (cf dcache_hit)
+                                            r_dcache_fsm [num_cache] = DCACHE_IDLE;
+
+                                            _drsp.valid   = true;
+                                            _drsp.rdata   = dcache_rdata; // return read data (cf dcache_hit)
                                             
                                             // if the request is a Load Linked instruction, save request information
-                                            if(dreq.type == iss_t::DATA_LL)
+                                            if(_dreq.type == iss_t::DATA_LL)
                                                 {
-                                                    PRINTF("    * <DCACHE> ll_valid = true\n");
-
-                                                    r_dcache_ll_valid = true;
-                                                    r_dcache_ll_data = dcache_rdata;
-                                                    r_dcache_ll_addr = (vci_addr_t) dreq.addr;
+                                                    PRINTF("    * <DCACHE [%d]> ll_valid = true\n",num_cache);
+
+                                                    r_dcache_ll_valid  [num_cache][dcache_num_cpu] = true;
+                                                    r_dcache_ll_data   [num_cache][dcache_num_cpu] = dcache_rdata;
+                                                    r_dcache_ll_addr   [num_cache][dcache_num_cpu] = (vci_addr_t) _dreq.addr;
 #ifdef COHERENCE_DEBUG
-                                                    std::cout << "Value returned for LL at address : " << std::hex << dreq.addr << " data : " << std::dec << dcache_rdata<< std::endl;
-                                                    r_dcache.read((vci_addr_t) dreq.addr, &dcache_rdata);
-                                                    std::cout << "Value stored at this  address : " << std::hex << dreq.addr << " data : " << std::dec << dcache_rdata<< std::endl;
+                                                    std::cout << "Value returned for LL at address : " << std::hex << _dreq.addr << " data : " << std::dec << dcache_rdata<< std::endl;
+                                                    r_dcache[num_cache]->read((vci_addr_t) _dreq.addr, &dcache_rdata);
+                                                    std::cout << "Value stored at this  address : " << std::hex << _dreq.addr << " data : " << std::dec << dcache_rdata<< std::endl;
 #endif
                                                 }
@@ -1423,5 +2306,5 @@
                                             if (not dcache_cleanup_hit)
                                             {
-                                                CACHE_MISS_BUF_REQ_INIT(d);
+                                                CACHE_MISS_BUF_REQ_INIT(d,num_cache);
                                                 
                                                 // Miss : send signal at the CMD_FSM (via r_dcache_miss_req or r_dcache_unc_req)
@@ -1429,20 +2312,20 @@
                                                     m_cpt_data_read_miss++;
                                                     m_cost_data_miss_frz++;
-                                                    r_dcache_miss_req = true;
+                                                    r_dcache_miss_req [num_cache] = true;
 #if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                                                    r_dcache_fsm = DCACHE_MISS_VICTIM;
+                                                    r_dcache_fsm [num_cache] = DCACHE_MISS_VICTIM;
 #else
-                                                    r_dcache_fsm = DCACHE_MISS_WAIT;
+                                                    r_dcache_fsm [num_cache] = DCACHE_MISS_WAIT;
 #endif
                                                     
                                                 } else {
-                                                    if (not r_dcache_previous_unc.read()) // strongly order to the uncached access
+                                                    if (not r_dcache_previous_unc[num_cache].read()) // strongly order to the uncached access
                                                     {
-                                                        r_dcache_previous_unc = true;
+                                                        r_dcache_previous_unc[num_cache] = true;
                                                         
                                                         m_cpt_data_read_uncached++;
                                                         m_cost_unc_read_frz++;
-                                                        r_dcache_unc_req = true;
-                                                        r_dcache_fsm = DCACHE_UNC_WAIT;
+                                                        r_dcache_unc_req[num_cache] = true;
+                                                        r_dcache_fsm    [num_cache] = DCACHE_UNC_WAIT;
                                                     }
                                                 }
@@ -1453,7 +2336,7 @@
                             case iss_t::DATA_SC:
                             {
-                                PRINTF("    * <DCACHE> DATA_SC - ll_valid = %d\n",r_dcache_ll_valid.read());
-
-                                if (not r_dcache_previous_unc.read() and not dcache_cleanup_hit) // strongly order to the uncached access
+                                PRINTF("    * <DCACHE [%d]> DATA_SC - ll_valid = %d, num_cpu = %d\n",num_cache,r_dcache_ll_valid[num_cache][dcache_num_cpu].read(),dcache_num_cpu);
+
+                                if (not r_dcache_previous_unc[num_cache].read() and not dcache_cleanup_hit) // strongly order to the uncached access
                                 {
                                     //m_cpt_data_read_unc++; // instruction must read the memory in uncached mode
